import { DefuzzicationType } from '../defuzzify';
import { LinguisticVariable } from '../index';
import { LinguisticRule } from '../LinguisticRule';
export declare class FuzzyInferenceSystem {
    name: string;
    inputs: LinguisticVariable[];
    outputs: LinguisticVariable[];
    rules: LinguisticRule[];
    constructor(name: string, inputs?: LinguisticVariable[], outputs?: LinguisticVariable[]);
    addVariable: (variable: LinguisticVariable, type: 'Input' | 'Output') => this;
    addInput: (variable: LinguisticVariable) => this;
    addOutput: (variable: LinguisticVariable) => this;
    addRule: (rule: string) => this;
    checkAntecedentsAndConsequentAreValid: (antecedents: string[][], consequent: string[]) => void;
    solve: (type: 'Mamdani', args: Record<string, number>, defuzzicationMethod: DefuzzicationType) => number;
}
