"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinguisticVariable = void 0;
var LinguisticVariable = /** @class */ (function () {
    function LinguisticVariable(name, fuzzySets) {
        if (fuzzySets === void 0) { fuzzySets = []; }
        var _this = this;
        this.addSet = function (set) {
            if (_this.indexedFuzzySets[set.name] !== undefined) {
                throw new Error('A set with that name already exists');
            }
            _this.fuzzySets.push(set);
            _this.indexedFuzzySets[set.name] = set;
            return _this;
        };
        this.getSet = function (name) {
            if (_this.indexedFuzzySets[name] === undefined) {
                throw new Error('No set with that name exists');
            }
            return _this.indexedFuzzySets[name];
        };
        this.name = name;
        this.fuzzySets = fuzzySets;
        this.indexedFuzzySets = fuzzySets.reduce(function (acc, fuzzySet) {
            var _a;
            return (__assign(__assign({}, acc), (_a = {}, _a[fuzzySet.name] = fuzzySet, _a)));
        }, {});
    }
    return LinguisticVariable;
}());
exports.LinguisticVariable = LinguisticVariable;
